from Framework import Controller,StaticController,templatepage
from Framework.PluginManager import DeclarePlugin
from Tools.SecurityModuleCore import SecurityToken, RedirectToLocalPage, RedirectAway
from Tools.SecurityModuleCore import Group, Role, NotAuthenticated, FetchFromArgs
from Tools.SecurityModuleCore import is_authorized, is_authenticated, has_site
from CondDBCommon import RedirectorToLogin
import cherrypy
from cherrypy import expose, request ,response
from cherrypy.lib import static
import os.path
import urllib2
import simplejson as json
import pickle
class LuminosityCfg(object):
   templatePath=staticmethod(lambda : os.path.join(__file__.rsplit ("/", 1)[0], "Templates"))
class Luminosity(Controller):
   def __init__(self,context):
        self.context=context
        self.__showimageurl=''
        Controller.__init__(self,context,__file__)
        self.__basepath = __file__.rsplit('/', 1)[0]
        self.context.addService (LuminosityCfg())
        self.__appurl=context.CondDBCommonCfg().appserverURL()+'/lumi'
        self.__tmpfilename='/tmp/dummy.png'
        url=self.__appurl+'/allLumiTags'
        response=urllib2.urlopen(urllib2.Request(url))
        livedata=json.loads(response.read())
        dummydata=[{'tagname':'chi','classname':'luminosity','startrun':1,'endrun':4,'plot':1,'operationlog':'USER=futyand;HOSTNAME=srv-C2C04-21;PWD=/nfshome0/futyand/CMSSW_3_1_0_pre9/src;','revision': 0,'accountname':'dummy'},{'tagname':'cruzet','classname':'luminosity','startrun':80,'endrun':84,'plot':1,'operationlog':'USER=futyand;HOSTNAME=srv-C2C04-21;PWD=/nfshome0/futyand/CMSSW_3_1_0_pre9/src;','revision': 0,'accountname':'dummy'},{'tagname':'craft','classname':'luminosity','startrun':9080,'endrun':9084,'plot':1,'operationlog':'USER=futyand;HOSTNAME=srv-C2C04-21;PWD=/nfshome0/futyand/CMSSW_3_1_0_pre9/src;','revision': 0,'accountname':'dummy'},{'tagname':'crame','classname':'hltinfo','startrun':9080,'endrun':9090,'plot':0,'operationlog':'USER=futyand;HOSTNAME=srv-C2C04-21;PWD=/nfshome0/futyand/CMSSW_3_1_0_pre9/src;','revision': 0,'accountname':'dummy'},{'tagname':'cream','classname':'hltinfo','startrun':10,'endrun':90,'plot':0,'operationlog':'USER=futyand;HOSTNAME=srv-C2C04-21;PWD=/nfshome0/futyand/CMSSW_3_1_0_pre9/src;','revision': 0,'accountname':'dummy'}]
        #self.__alldata={
        #    "dummy":{"ResultSet":{"status":"OK","data":dummydata}},
        #    "oracle://cms_orcoff_prep/CMS_COND_RUN_INFO":{'ResultSet':{'status':livedata['oracle://cms_orcoff_prep/CMS_COND_RUN_INFO']['status'],'data':livedata['oracle://cms_orcoff_prep/CMS_COND_RUN_INFO']['data']}},
        #    "oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO":{'ResultSet':{'status':livedata['oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO']['status'],'data':livedata['oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO']['data']}}
        #}
        self.__alldata={
            "dummy":{"ResultSet":{"status":"OK","data":dummydata}},
            "oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO":{'ResultSet':{'status':livedata['oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO']['status'],'data':livedata['oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO']['data']}}
        }
        
        #initial dummy data. updated with live data on request
        self.__summarydata={('dummy','chi'):{1:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},2:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},3:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},4:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)}},
                            ('dummy','cruzet'):{80:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},81:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},82:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},83:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},84:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)}},
                            ('dummy','craft'):{9080:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},9081:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},9082:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},9083:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)},9084:{1:(0.5,0.9),2:(0.8,0.9),3:(0.1,0.9),4:(-0.1,1)}}
                           }
   @expose
   @is_authenticated( onFail=RedirectorToLogin("../IOVManagement/index"))
   def index(self):
       result=self.templatePage("index",{})
       return result
   
   @expose
   @is_authenticated( onFail=RedirectorToLogin("../lumi/index"))
   def datatable(self,account):
      result=self.__alldata[account]
      return json.dumps(result)
  
   @expose
   @is_authenticated( onFail=RedirectorToLogin("../lumi/index"))
   def showimage(self):
      self.__showimageurl=cherrypy.url()
      response.headers['Content-Type']="image/png"
      f=open(self.__tmpfilename,"rb")
      contents=f.read()
      f.close()
      return contents

   def retrieveSummaryData(self,account,tag):
      """
      """
      mydata=urllib2.urlopen(self.__appurl+'/LumiSummaries/?account='+account+'&tag='+tag).read()
      import pickle
      result=pickle.loads(mydata)         
      self.__summarydata[(account,tag)]=result
      return result
    
   @expose
   @is_authenticated( onFail=RedirectorToLogin("../lumi/index"))
   def drawlumisummary(self,account,tag,runnumber):
      """draw lumi average vs lumisection
      Input: 
        runnumber:
        #lumiavgpersection:dictionary {lumisection:(lumiavg,norm factor),...}           #lumiavg: dictionary {run:lumiavgpersection}#only used here
      """
      _header="""
         <html>
         <head>
         </head>
         <body>"""
      _footer="""
         </body>
         </html>"""
      if not self.__summarydata.has_key((account,tag)):
         self.retrieveSummaryData(account,tag)
      if not self.__summarydata.has_key((account,tag)):
         page=[_header]
         page.append('no data found for tag '+tag+' in account '+account)
         page.append(_footer)
         return page
      #print account,tag,runnumber
      mylumiavgpersection=self.__summarydata[(account,tag)][int(runnumber)]
      import matplotlib
      #IMPORTANT: must call this before import pylab. 
      matplotlib.use('Agg')
      import matplotlib.pylab as plt
      #construct your plot
      fig=plt.figure()
      a=fig.add_subplot(111)
      #a.clf()
      plottitle='luminosity for Run '+str(runnumber)
      a.set_title(plottitle)
      a.set_xlabel('lumi section')
      a.set_ylabel('lumi average')
      a.grid()
      a.plot(mylumiavgpersection.keys(),[v for (v,normfactor) in mylumiavgpersection.values()],'rs-',linewidth=1.0,label='recorded')
      a.plot(mylumiavgpersection.keys(),[v*normfactor for (v,normfactor) in mylumiavgpersection.values() ], 'gs-',linewidth=1.0,label='delivered')
      a.legend()
      fig.savefig(self.__tmpfilename,format='png')
      response.headers['Content-Type']='text/html'
      page=[_header]
      (opts, args) = self.context.OptionParser().parse_args ()
      page.append('<img src="'+'/'.join([opts.baseUrl,'lumi','showimage'])+'" width="800" height="400" />')
      page.append(_footer)
      return page

DeclarePlugin ("/Controllers/CondDB/Luminosity", Luminosity, {"baseUrl": "/lumi"})
